
class Ulamek {
  private int licznik,mianownik;
  
  public Ulamek(int licznik,int mianownik) {
    assert mianownik!=0;
    this.licznik=licznik;
    this.mianownik=mianownik;
    skroc();
  }
  
  public Ulamek(int licznik) {
    this.licznik=licznik;
    this.mianownik=1;
  }
  
  public Ulamek dodaj(Ulamek co) {
    return new Ulamek(
		this.licznik*co.mianownik+co.licznik*this.mianownik,
		co.mianownik*this.mianownik);
  }

  public Ulamek pomnoz(Ulamek co) {
    return new Ulamek(
		this.licznik*co.licznik,
		this.mianownik*co.mianownik);
  }

  public Ulamek odejmij(Ulamek u) {
    return dodaj(u.neguj());
  }

  public Ulamek podziel(Ulamek u) {
    return pomnoz(u.odwroc());
  }

  public Ulamek dodaj(int wartosc) {
    return dodaj(new Ulamek(wartosc));
  }

  public Ulamek odejmij(int wartosc) {
    return odejmij(new Ulamek(wartosc));
  }

  public Ulamek pomnoz(int wartosc) {
    return pomnoz(new Ulamek(wartosc));
  }

  public Ulamek podziel(int wartosc) {
    return podziel(new Ulamek(wartosc));
  }
  
  public String toString() {
    return Integer.toString(licznik)+"/"+Integer.toString(mianownik);
  }

  public int compareTo(Ulamek u) {
    if (u==this) return 0;
    int a1=this.licznik*u.mianownik;
    int a2=u.licznik*this.mianownik;
    int b=this.mianownik*u.mianownik;
    if (a1<a2) return -1;
    else if (a1==a2) return 0;
    else return 1;
  }
  
  private void skroc() {
    if (mianownik<0) {
	mianownik*=-1;
	licznik*=-1;
    }
    int nwd=nwd(licznik,mianownik);
    licznik/=nwd;
    mianownik/=nwd;
  }
  
  private int nwd(int a,int b) {
    if (b==0) return a;
    else return nwd(b,a%b);
  }

  private Ulamek neguj() {
    return new Ulamek(-this.licznik,this.mianownik);
  }
  private Ulamek odwroc() {
    return new Ulamek(this.mianownik,this.licznik);
  }

  
}
